package org.xbib.event.common;

import org.xbib.event.Listener;

import java.util.Objects;

public class GenericEventImpl extends EventManager.EventImpl {

    private final EventManager.EventBuilder builder;

    public GenericEventImpl(EventManager.EventBuilder builder) {
        this(builder, null);
    }

    public GenericEventImpl(EventManager.EventBuilder builder, Listener listener) {
        super(builder);
        this.builder = builder;
        this.builder.listener = Objects.requireNonNull(listener);
    }

    public GenericEventImpl setListener(Listener listener) {
        this.builder.listener = Objects.requireNonNull(listener);
        return this;
    }

    public void received() {
        builder.listener.listen(this);
    }
}
