package org.xbib.event.timer;

import org.junit.jupiter.api.Test;
import org.xbib.event.Payload;
import org.xbib.event.common.EventManager;
import org.xbib.settings.Settings;

import java.io.IOException;
import java.time.Instant;
import java.util.Map;

public class TimerEventManagerTest {

    @Test
    public void testTimerEvents() throws IOException, InterruptedException {
        TestTimerEventConsumer consumer = new TestTimerEventConsumer();
        Settings settings = Settings.settingsBuilder()
                .put("event.timer.testtimerevent.enabled", "true")
                .build();
        EventManager eventManager = EventManager.builder()
                .setSettings(settings)
                .register(consumer)
                .build();
        TimerEventManagerService timerEventManager = eventManager.getTimerEventManagerService();
        Payload payload = new Payload(Map.of("a", "b"));
        timerEventManager.publish("testtimerevent", Instant.now().plusSeconds(5L), payload);
        Thread.sleep(10000L);
        timerEventManager.shutdown();
    }
}
